var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F01222;
(function (F01222) {
    var StrKeysP1TotalF012Xx = F012XX.P1TotalStrKeys;
    var FDocument = (function (_super) {
        __extends(FDocument, _super);
        function FDocument(id, version, oldVersion) {
            var _this = _super.call(this, id, version, oldVersion) || this;
            _this._p4Sp3Table = null;
            _this._p6Sp1Table = null;
            _this._p6Sp2Table = null;
            _this._p6Sp3Table = null;
            _this._p6Sp6Table = null;
            _this._p6Sp1Sheet = null;
            _this._p6Sp2Sheet = null;
            _this._p6Sp6Sheet = null;
            _this._countMonthForCalcTable = null;
            _this._interfaceRules = new F01222.InterfaceRules(_this);
            _this._updateRules = new F01222.UpdateRules(_this);
            return _this;
        }
        Object.defineProperty(FDocument.prototype, "InterfaceRules", {
            get: function () {
                return this._interfaceRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "UpdateRules", {
            get: function () {
                return this._updateRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P4Sp3Table", {
            get: function () {
                if (this._p4Sp3Table == null) {
                    this._p4Sp3Table = new F01222.P4Sp3ObasTable("F01_211_4_2", this);
                }
                return this._p4Sp3Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp1Table", {
            get: function () {
                if (this._p6Sp1Table == null) {
                    this._p6Sp1Table = new F01211.PXSp1ObasTable("F01_222_6_1_Values", this, StrKeysP1TotalF012Xx.P6, FDocument._keyFieldIs);
                }
                return this._p6Sp1Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp2Table", {
            get: function () {
                if (this._p6Sp2Table == null) {
                    this._p6Sp2Table = new F01211.PXSp2ObasTable("F01_222_6_2_Values", this, this.P6Sp1Table, this.P6Sp6Table, FDocument._keyFieldIs, "F01_222_6_2_Rows");
                }
                return this._p6Sp2Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp3Table", {
            get: function () {
                if (this._p6Sp3Table == null) {
                    this._p6Sp3Table = new F01222.P6Sp3Sp4ObasTable("F01_222_r6_3_r6_4", this, this.P6Sp2Table, this.P6Sp6Table);
                }
                return this._p6Sp3Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp6Table", {
            get: function () {
                if (this._p6Sp6Table == null) {
                    this._p6Sp6Table = new F01211.PXSp6ObasTable("F01_222_6_6_Values", this, this.P6Sp1Table);
                }
                return this._p6Sp6Table;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp1Sheet", {
            get: function () {
                if (this._p6Sp1Sheet == null) {
                    this._p6Sp1Sheet = new F01211.PXSp1Sheet("SHT_F01_222_6_1", this, this.P6Sp1Table.IsEditCorrection);
                }
                return this._p6Sp1Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp2Sheet", {
            get: function () {
                if (this._p6Sp2Sheet == null) {
                    this._p6Sp2Sheet = new F012XX.IndexSheet("SHT_F01_222_6_2_Grid", this, 1);
                }
                return this._p6Sp2Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P6Sp6Sheet", {
            get: function () {
                if (this._p6Sp6Sheet == null) {
                    this._p6Sp6Sheet = new InsuranceSheet("SHT_F01_222_6_6", this);
                }
                return this._p6Sp6Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "CountMonthForCalcTable", {
            get: function () {
                if (this._countMonthForCalcTable == null) {
                    this._countMonthForCalcTable = new F01222.CountMonthForCalcTable("CountMonthForCalc", this);
                }
                return this._countMonthForCalcTable;
            },
            enumerable: true,
            configurable: true
        });
        return FDocument;
    }(F01212.FDocument));
    F01222.FDocument = FDocument;
})(F01222 || (F01222 = {}));
